<script lang="ts">
// This temporary component is meant to replace the one in `components/pull-quote.vue` so we can isolate the changes required in
// https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience/-/merge_requests/300#note_882417119
// Once we fix the typography as per https://gitlab.com/gitlab-com/marketing/digital-experience/slippers-ui/-/issues/127,
// we should go tback to `components/pull-quote.vue`, update there, and then swap this out to the top-level shared component.
import Vue from 'vue';
import { SlpHorizontalRule } from '../common/index.vue';

export default Vue.extend({
  name: 'TempCustomersPullQuote',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      quoteIndex: 0,
      quoteInterval: setInterval(() => {}, 30000),
    };
  },
  computed: {
    selectedQuote(): Object {
      if (!this.data.multiple_quotes) {
        return this.data;
      }
      return this.data.quotes[this.quoteIndex];
    },
  },
  mounted() {
    if (!this.data.quotes) {
      return;
    }
    this.clearQuoteTimer();
  },
  methods: {
    increaseIndex(): void {
      const totalQuotes = this.data.quotes.length;
      if (this.quoteIndex + 1 >= totalQuotes) {
        this.quoteIndex = 0;
      } else {
        this.quoteIndex += 1;
      }
      this.clearQuoteTimer();
    },
    clearQuoteTimer() {
      clearInterval(this.quoteInterval);
      this.quoteInterval = setInterval(this.increaseIndex, 30000);
    },
  },
});
</script>

<template>
  <section
    :class="{ [`variant-${data.variant}`]: data.variant }"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
  >
    <div
      class="container"
      :class="{
        'container__shadow container': data.shadow,
        [`shadow-left`]: data.invert_shadow,
        'slp-mb-96': selectedQuote.hide_horizontal_rule,
      }"
    >
      <div v-if="selectedQuote.image" class="image-container">
        <nuxt-img
          v-if="selectedQuote.image"
          class="quote-image"
          :src="selectedQuote.image.image_url"
          :alt="selectedQuote.image.image_alt"
          loading="lazy"
        />
        <button
          v-if="data.multiple_quotes"
          class="quote-button"
          @click="increaseIndex"
        >
          <nuxt-img src="/nuxt-images/icons/arrow.svg" alt="" loading="lazy" />
        </button>
      </div>
      <svg width="30" height="25" fill="none" class="quote-icon">
        <path
          d="M10.79.19C4.07 3.48.85 8.59.85 15.17c0 5.74 2.24 9.17 6.58 9.17 3.08 0 5.39-2.24 5.39-5.74 0-3.15-2.45-5.11-5.39-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L10.79.19zm16.59 0c-6.72 3.29-10.01 8.4-10.01 14.98 0 5.74 2.31 9.17 6.65 9.17 3.08 0 5.32-2.24 5.32-5.74 0-3.15-2.38-5.11-5.32-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L27.38.19z"
          fill="#9B51E0"
        />
      </svg>
      <SlpTypography tag="p" variant="body1" class="quote">{{
        selectedQuote.quote
      }}</SlpTypography>
      <SlpTypography tag="p" variant="body1" class="source">{{
        selectedQuote.source
      }}</SlpTypography>
      <cite class="cite">{{ selectedQuote.cite }}</cite>
      <a
        v-if="selectedQuote.link_href"
        :href="selectedQuote.link_href"
        class="slp-text-xxs quote-link"
        variant="primary"
        :data-ga-name="selectedQuote.data_ga_name"
        :data-ga-location="selectedQuote.data_ga_location"
      >
        {{ selectedQuote.link_text }} →
      </a>
    </div>
    <SlpHorizontalRule v-if="!selectedQuote.hide_horizontal_rule" />
  </section>
</template>

<style lang="scss" scoped>
.container {
  display: flex;
  padding: 48px 95px;
  flex-direction: column;
  text-align: center;
  align-items: center;
  border: 1px solid rgba(0, 0, 0, 0.08);
  box-sizing: border-box;
  border-radius: 4px;
  position: relative;
  background: #ffffff;

  @media (max-width: $breakpoint-lg) {
    padding: $spacing-48;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-24;
  }

  &__shadow {
    box-shadow: 21px 21px 0 #f2f2f2;
    margin: 0 auto;
    max-width: 95%;
    @media (min-width: $breakpoint-lg) {
      max-width: 80%;
    }
    &.shadow-left {
      box-shadow: -21px 21px 0 #f2f2f2;
    }
  }

  .image-container {
    display: flex;
    width: 100%;
    justify-content: space-between;
    align-items: center;
    margin-bottom: $spacing-48;
  }

  .quote {
    color: '#333333';
    line-height: 38px;
    font-size: 23px;
    font-style: italic;
    font-weight: 400;
    margin-bottom: $spacing-32;
  }

  .quote-icon {
    margin-bottom: $spacing-32;
  }

  .quote-link {
    margin-bottom: 0;
  }

  .source {
    font-weight: 700;
  }

  .cite {
    font-style: normal;
    font-size: 10px;
    letter-spacing: 1.5px;
  }

  .quote-image {
    max-width: 160px;
    height: 65px;
    object-fit: contain;
  }

  .quote-button {
    border: 1px solid #7d2bd9;
    width: 40px;
    height: 40px;
    border-radius: 30px;
    background: white;
    position: absolute;
    right: -20px;
    color: #7d2bd9;
    cursor: pointer;
  }

  a {
    color: #7d2bd9;
    font-size: 14px;
    line-height: 2rem;
    letter-spacing: 1px;
    margin-bottom: $spacing-48;
  }
}

section {
  &.variant {
    &-compact {
      .container {
        text-align: left;
        padding: 48px $spacing-32;
        .quote-image,
        .quote-icon,
        .quote-link {
          align-self: flex-start;
        }

        .quote-icon {
          margin-bottom: $spacing-24;
        }

        .source {
          align-self: flex-start;
          font-weight: 400;
          font-size: 16px;
          line-height: 24px;
        }

        a {
          letter-spacing: 0;
        }
      }
    }
  }
}
</style>
